package hw2;

import static org.junit.Assert.assertEquals;

import java.util.ArrayList;

import org.junit.Test;


public class GameTest {

		// TODO Auto-generated method stub
		@Test
		public void testInitialConstructor1(){
			Game game = new Game("Hello, World!", 5);
			String msg = "The game constructed with 5 max guesses should get 5 max wrong guesses"; 
			assertEquals(msg, 5, game.getMaxGuesses());			
		}
		
		@Test
		public void testInitialConstructor2(){
			Game game = new Game("Hello, World!");
			String msg = "The default max guesses should be 7"; 
			assertEquals(msg, 7, game.getMaxGuesses());			
		}
		
		@Test
		public void testEdgeMaxGuess1(){
			Game game = new Game("Hello, World!", 5);
			guessChar(1, 'H', game);
			guessChar(1, 'e', game);
			guessChar(1, 'l', game);
			guessChar(1, 'o', game);
			guessChar(1, 'W', game);
			guessChar(1, 'd', game);
			guessChar(1, 'r', game);
			guessChar(1, 'A', game);
			String msg = "After guessing H, e, l, o, W, r, d, and A, with Hello, World! as secret phrase, the number of wrong guesses should be 0 ";
			assertEquals(msg, 0, game.numWrongGuesses());	 
		}
		
		@Test
		public void testEdgeMaxGuess2(){
			Game game = new Game("Hello, World!", 0);
			guessChar(1, 'H', game);
			guessChar(1, 'e', game);
			guessChar(1, 'l', game);
			guessChar(1, 'o', game);
			guessChar(1, 'W', game);
			guessChar(1, 'd', game);
			guessChar(1, 'r', game);
//			guessChar(1, 'A', game);
			String msg = "After guessing H, e, l, o, W, d and r, with Hello, World! as secret phrase, the won should return false ";
			assertEquals(msg, false, game.won());	 
		}
		
		@Test
		public void testEdgeMaxGuess3(){
			Game game = new Game("Hello, World!", -1);
			guessChar(1, 'H', game);
			guessChar(1, 'e', game);
			guessChar(1, 'l', game);
			guessChar(1, 'o', game);
			guessChar(1, 'W', game);
			guessChar(1, 'd', game);
			guessChar(1, 'r', game);
//			guessChar(1, 'A', game);
			String msg = "After guessing H, e, l, o, W, d and r, with Hello, World! as secret phrase, the won should return false ";
			assertEquals(msg, false, game.won());	 
		}
		
		@Test
		public void testInitialMaxGuesses1() {
			Game game = new Game("Hello, World!");
			String msg = "The default max guesses should be 7"; 
			assertEquals(msg, 7, game.getMaxGuesses());			
		}
		
		@Test
		public void testInitialMaxGuesses2(){
			Game game = new Game("Hello, World!", 5);
			String msg = "The default max guesses of a Game(\"Hello, World!\", 5) should be 5"; 
			assertEquals(msg, 5, game.getMaxGuesses());		
		}
		
		@Test
		public void testInitialMaxGuesses3(){
			Game game = new Game("Hello, World!", 0);
			String msg = "The default max guesses of The default max guesses of a Game(\"Hello, World!\", 0) should be 0"; 
			assertEquals(msg, 0, game.getMaxGuesses());		
		}
		
		@Test
		public void testInitialDisplayedWord1(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			String msg = "The letters should be hidden and non letters should not be hidden";		
			HideableChar[] testChar = stringToHideableChar(testWord);			
			assertEquals(msg, true, equalsHideableChar(game.getDisplayedWord(), testChar));		
			
		}
		
		@Test
		public void testInitialDisplayedWordOnlyLetters(){
			String testWord = "Hello";
			Game game = new Game(testWord);
			String msg = "The letters should be hidden and non letters should not be hidden";		
			HideableChar[] testChar = stringToHideableChar(testWord);			
			assertEquals(msg, true, equalsHideableChar(game.getDisplayedWord(), testChar));		
			
		}
		
		@Test
		public void testInitialDisplayedWordWithoutLetters(){
			String testWord = "!!";
			Game game = new Game(testWord);
			String msg = "The letters should be hidden and non letters should not be hidden";		
			HideableChar[] testChar = stringToHideableChar(testWord);			
			assertEquals(msg, true, equalsHideableChar(game.getDisplayedWord(), testChar));		
			
		}
		
		@Test
		public void testInitialSecretWord1(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			String msg = "The secret word should be Hello, World!";
			assertEquals(msg, testWord, game.getSecretWord());		
		}
		
		@Test
		public void testWrongGuessCount1(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			game.guessLetter('a');
			String msg = "After guessing a, with Hello, World! as secret phrase, the number of wrong guesses should be 1 ";
			assertEquals(msg, 1, game.numWrongGuesses());		
		}
		
		@Test
		public void testWrongGuessCount2(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(2, 'a', game);
			String msg = "After guessing a twice, with Hello, World! as secret phrase, the number of wrong guesses should be 2 ";
			assertEquals(msg, 2, game.numWrongGuesses());		
		}
		
		@Test
		public void testWrongGuessCount3(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(8, 'a', game);
			String msg = "A game with default 7 max wrong guesses, after guessing a eight times, with Hello, World! as secret phrase, the number of wrong guesses should be 7 ";
			assertEquals(msg, 7, game.numWrongGuesses());		
		}
		
		@Test
		public void testWrongGuessCount4(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord, 3);
			guessChar(8, 'a', game);
			String msg = "A game with 3 max wrong guesses, after guessing a 8 times, with Hello, World! as secret phrase, the number of wrong guesses should be 3 ";
			assertEquals(msg, 3, game.numWrongGuesses());		
		}
		
		@Test
		public void testWrongGuessCountSpace(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(1, ' ', game);
			String msg = "After guessing space once, with Hello, World! as secret phrase, the number of wrong guesses should be 1 ";
			assertEquals(msg, 1, game.numWrongGuesses());		
		}
		
		@Test
		public void testWrongGuessCountAllGuessRight(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(1, 'H', game);
			guessChar(1, 'e', game);
			guessChar(1, 'l', game);
			guessChar(1, 'o', game);
			guessChar(1, 'W', game);
			guessChar(1, 'd', game);
			guessChar(1, 'r', game);
			String msg = "After guessing H, e, l, o, W, e, d, and r, with Hello, World! as secret phrase, the number of wrong guesses should be 0 ";
			assertEquals(msg, 0, game.numWrongGuesses());		
		}
		 
		@Test
		public void testLettersGuessedRepeatingGuessA(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(3, 'a', game);
			String msg = "After guessing a 3 times, with Hello, World! as secret phrase, the letter guessed should be A";
			assertEquals(msg, "a", game.lettersGuessed());
		}
		
		@Test
		public void testLettersGuessedGuessLowerCaseAOnce(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			game.guessLetter('a');
			String msg = "After guessing a once, with Hello, World! as secret phrase, the letter guessed should be A";
			assertEquals(msg, "a", game.lettersGuessed());
		}
		
		@Test
		public void testLettersGuessedGuessUpperCaseAOnce(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			game.guessLetter('A');
			String msg = "After guessing A once, with Hello, World! as secret phrase, the letter guessed should be A";
			assertEquals(msg, "A", game.lettersGuessed());
		}
		
		@Test
		public void testLettersGuessedRepeatingGuessAAndB(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(3, 'a', game);
			guessChar(3, 'b', game);
			String msg = "After guessing a and b 3 times, with Hello, World! as secret phrase, the letter guessed should be AB";
			assertEquals(msg, "ab", game.lettersGuessed());
		}
		
		@Test
		public void testLettersGuessedAllRightGuesses(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(1, 'H', game);
			guessChar(1, 'e', game);
			guessChar(1, 'l', game);
			guessChar(1, 'o', game);
			guessChar(1, 'W', game);
			guessChar(1, 'd', game);
			guessChar(1, 'r', game);
			String msg = "After guessing H, e, l, o, W, e, r, and d, with Hello, World! as secret phrase, the letter guessed should be HeloWedr";
			assertEquals(msg, "HeloWdr", game.lettersGuessed());
		}
		
		@Test
		public void testLettersGuessedSpace(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(1, ' ', game);
			String msg = "After guessing space once, with Hello, World! as secret phrase, the letter guessed should be  ";
			assertEquals(msg, " ", game.lettersGuessed());
		}
		
		@Test
		public void testLettersGuessedDash(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(2, '-', game);
			String msg = "After guessing - twice, with Hello, World! as secret phrase, the letter guessed should be -";
			assertEquals(msg, "-", game.lettersGuessed());
		}
		
		@Test
		public void testLettersGuessedDashLetter(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(1, '-', game);
			guessChar(1, 'e', game);
			String msg = "After guessing - and e, with Hello, World! as secret phrase, the letter guessed should be -e";
			assertEquals(msg, "-e", game.lettersGuessed());
		}
		
		@Test
		public void testWonGameOverAllRightGuesses(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(1, 'H', game);
			guessChar(1, 'e', game);
			guessChar(1, 'l', game);
			guessChar(1, 'o', game);
			guessChar(1, 'W', game);
			guessChar(1, 'd', game);
			guessChar(1, 'r', game);
			String msg = "After guessing H, e, l, o, W, e, r, and d, with Hello, World! as secret phrase, won status should be true and game should be over";
			assertEquals(msg, true, game.won());
			assertEquals(msg, true, game.gameOver());
		}
		
		@Test
		public void testWonGameOverNotExceedingMaxWrongGuesses(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(6, 'a', game);
			guessChar(1, 'H', game);
			guessChar(1, 'e', game);
			guessChar(1, 'l', game);
			guessChar(1, 'o', game);
			guessChar(1, 'W', game);
			guessChar(1, 'd', game);
			guessChar(1, 'r', game);
			String msg = "After guessing a for 6 times and guessing H, e, l, o, W, d and r each once, with Hello, World! as secret phrase, won status should be true and game should be over";
			assertEquals(msg, true, game.won());
			assertEquals(msg, true, game.gameOver());
		}
		
		@Test
		public void testWonGameOverExceedingMaxWrongGuesses(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			guessChar(8, 'a', game);
			guessChar(1, 'H', game);
			guessChar(1, 'e', game);
			guessChar(1, 'l', game);
			guessChar(1, 'o', game);
			guessChar(1, 'W', game);
			guessChar(1, 'd', game);
			guessChar(1, 'r', game);
			String msg = "After guessing a for 8 times and guessing H, e, l, o, W, d and r each once, with Hello, World! as secret phrase, won status should be false and game should be over";
			assertEquals(msg, false, game.won());
			assertEquals(msg, true, game.gameOver());
		}
		
		@Test
		public void testWonGameOverWithoutLetters(){
			String testWord = "!@$ ";
			Game game = new Game(testWord);
//			guessChar(1, '!', game);
			String msg = "Without guessing any letter, with the word \"!@$ \", the game should be won and game should be over";
			assertEquals(msg, true, game.won());
			assertEquals(msg, true, game.gameOver());
		}
		
		@Test
		public void testWonGameOverWithoutLetters2(){
			String testWord = "!@$ ";
			Game game = new Game(testWord);
			guessChar(1, '!', game);
			String msg = "After guessing !, with the word \"!@$ \", the game should be won and game should be over";
			assertEquals(msg, true, game.won());
			assertEquals(msg, true, game.gameOver());
		}
		
//		@Test
//		public void testGameOverNotExceedingMaxWrongGuesses(){
//			String testWord = "Hello, World!";
//			Game game = new Game(testWord);
//			guessChar(5, 'a', game);
//			guessChar(1, 'H', game);
//			guessChar(1, 'e', game);
//			guessChar(1, 'l', game);
//			guessChar(1, 'o', game);
//			guessChar(1, 'W', game);
//			guessChar(1, 'd', game);
//			guessChar(1, 'r', game);
//			String msg = "After guessing a for 5 times and guessing H, e, l, o, W, d and r each once, with Hello, World! as secret phrase, game should be over";
//			assertEquals(msg, true, game.gameOver());
//		}
		
		
//		@Test
//		public void testGameOverExceedingMaxWrongGuesses(){
//			String testWord = "Hello, World!";
//			Game game = new Game(testWord);
//			guessChar(8, 'a', game);
//			guessChar(1, 'H', game);
//			guessChar(1, 'e', game);
//			guessChar(1, 'l', game);
//			guessChar(1, 'o', game);
//			guessChar(1, 'W', game);
//			guessChar(1, 'd', game);
//			guessChar(1, 'r', game);
//			String msg = "After guessing a for 8 times and guessing H, e, l, o, W, d and r each once, with Hello, World! as secret phrase, game should be over";
//			assertEquals(msg, true, game.gameOver());
//		}
		
		@Test
		public void testGuessLetterWrongGuess1(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			String msg = "After guessing a once, with Hello, World! as secret phrase, guessLetter should return false";
			assertEquals(msg, false, game.guessLetter('a'));
		}
		
		@Test
		public void testGuessLetterWrongGuessCaseSensitive1(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			String msg = "After guessing h once, with Hello, World! as secret phrase, guessLetter should return false";
			assertEquals(msg, false, game.guessLetter('h'));
		}
		
		@Test
		public void testGuessLetterWrongGuessCaseSensitive2(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			String msg = "After guessing E once, with Hello, World! as secret phrase, guessLetter should return false";
			assertEquals(msg, false, game.guessLetter('E'));
		}
		
		@Test
		public void testGuessLetterWrongGuessExMark(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			String msg = "After guessing ! once, with Hello, World! as secret phrase, guessLetter should return false";
			assertEquals(msg, false, game.guessLetter('!'));
		}
		
		@Test
		public void testGuessLetterWrongGuessSpace(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			String msg = "After guessing space once, with Hello, World! as secret phrase, guessLetter should return false";
			assertEquals(msg, false, game.guessLetter(' '));
		}
		
		@Test
		public void testGuessLetterRightGuess1(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			String msg = "After guessing H once, with Hello, World! as secret phrase, guessLetter should return true";
			assertEquals(msg, true, game.guessLetter('H'));
		}
		
		@Test
		public void testGuessLetterRightGuess2(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			String msg = "After guessing e once, with Hello, World! as secret phrase, guessLetter should return true";
			assertEquals(msg, true, game.guessLetter('e'));
		}
				
		
		@Test
		public void testDisplayedWordAfterGuess1(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			game.guessLetter('H');
			String msg = "After guessing H once, with Hello, World! as secret phrase, the letters except H should be hidden and non letters should not be hidden";
			HideableChar[] testChars = stringToHideableChar(testWord);
			unHideChar(testChars, 'H');
			assertEquals(msg, true, equalsHideableChar(game.getDisplayedWord(), testChars ));
		}
		
		@Test
		public void testDisplayedWordAfterGuess2(){
			String testWord = "Hello, World!";
			Game game = new Game(testWord);
			game.guessLetter('A');
			String msg = "After guessing A once, with Hello, World! as secret phrase, the letters should be hidden and non letters should not be hidden";
			HideableChar[] testChars = stringToHideableChar(testWord);
//			unHideChar(testChars, 'A');
			assertEquals(msg, true, equalsHideableChar(game.getDisplayedWord(), testChars ));
		}
		
		private void unHideChar(HideableChar[] hideableChars, char ch){
			for (int i = 0; i < hideableChars.length; i++){
				if (hideableChars[i].getHiddenChar().equals(ch + "")){
					hideableChars[i].unHide();
				}
			}
		}
		
		private boolean equalsHideableChar(HideableChar[] chars1, HideableChar[] chars2){
			boolean allEqual = true;
			boolean[] charEqual = new boolean[chars1.length];
			for (int i = 0; i < chars1.length; i++)
			{
				boolean euqalHiddenStatus = (chars1[i].isHidden() == chars2[i].isHidden()) ;
				boolean equalChars = (chars1[i].getHiddenChar().equals(chars2[i].getHiddenChar()));
				charEqual[i] = euqalHiddenStatus && equalChars;
				if (!charEqual[i])
				{
					return false;
				}
			}			
			
			return allEqual;
		}
		
		private HideableChar[] stringToHideableChar(String s){
			
			HideableChar[] testChar = new HideableChar[s.length()];
			
			for (int i = 0; i < testChar.length; ++i){
				testChar[i] = new HideableChar(s.charAt(i));
			}
			
			return testChar;
		}
		
		private void guessChar(int times, char ch, Game game){
			for (int i = 0; i < times; ++ i ){
				game.guessLetter(ch);
			}
		}
		
}
